/*
 * common.h
 * code: SASANO Takayoshi
 * --- public domain, no warranty
 */

#include <bstdio.h>
#include <bstring.h>
#include <bstdlib.h>
#include <driver/driver.h>
#include <driver/usb.h>
#include <device/kbpd.h>
#include <kernel/util.h>
#include <util/libdbg.h>
#include <inner.h>
#include <errcode.h>

/* debug message */
#ifdef	DEBUG
#define	MESSAGE_LEVEL	4
#define	D(l, x)	if ((l) <= MESSAGE_LEVEL) printf x
#else
#define	D(l, x)	/* */
#endif

/* workarea */
#define	DATASIZE	64
typedef	struct	_workarea {
	/* device */
	W	device_did;
	W	device_iid;
	W	device_pid;

	W	device_pktsz;

	ID	device_porid;
	ID	device_tskid;

	/* data */
	ID	data_tskid;
	ID	data_mbfid;

	UB	data[DATASIZE];
} WorkArea;

/* task settings */
#define	DEVICE_PRI	80
#define	DEVICE_STKSZ	3072

#define	DATA_PRI	80
#define	DATA_STKSZ	3072

/* device.c */
IMPORT	ERR	device_start(WorkArea *wk);
IMPORT	ERR	device_finish(WorkArea *wk);

/* data.c */
IMPORT	ERR	device_detach(WorkArea *wk, DevReq *q, DevRsp *p);
IMPORT	ERR	data_start(WorkArea *wk);
IMPORT	ERR	data_finish(WorkArea *wk);
